# coding: utf-8

"""
    Python API wrapper for Jellyfish Media Server

    The version of the OpenAPI document: 0.2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr
from jellyfish._openapi_client.models.peer_status import PeerStatus

class Peer(BaseModel):
    """
    Describes peer status
    """
    id: StrictStr = Field(..., description="Assigned peer id")
    status: PeerStatus = Field(...)
    type: StrictStr = Field(..., description="Peer type")
    __properties = ["id", "status", "type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Peer:
        """Create an instance of Peer from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Peer:
        """Create an instance of Peer from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Peer.parse_obj(obj)

        _obj = Peer.parse_obj({
            "id": obj.get("id"),
            "status": obj.get("status"),
            "type": obj.get("type")
        })
        return _obj


